#include "simlib.h"

Store pocitace("Stroje", 10);

int je_plno = 0;
int celkem = 0;

class Student : public Process {
public:
	void akce() {
		Enter(pocitace, 1);
		Wait(Exponential(100));
		Leave(pocitace, 1);
	}
	
	void Behavior() {
		opak:
		celkem++;
		if (pocitace.Full()) {
			je_plno++;
			if (Random()<=0.6) akce();
				else {
					if (Random()<=0.2) {
						Wait(Uniform(30,60));
						goto opak;
					}
				}
		} else { akce(); }
	}
};

class Gener : public Event {
	void Behavior() {
		(new Student)->Activate();
		Activate(Time+Exponential(10));
	}
};

int main()
{
	Init(0,1000000);
	(new Gener)->Activate();
	Run();
	pocitace.Output();
	Print("Pravdepodobnost, ze bude plno: %f\n", (float)je_plno/celkem);
}
